
#include <PA9.h>
#include <math.h>
#include "DetuneMIDILoader.h"
#include "test.h"

inline int imod(int i, int j) {
  return (i % j) < 0 ? (i % j) + (j < 0 ? -j : j) : i % j;
}

int freqs[13] = {262,277,294,311,330,349,370,392,415,440,466,494,523}; //g̃e[u
void MidiCallBack(DetuneMIDI mid){
	//\
	char str[32];
	sprintf(str,"note=%u",mid.key-36);
	PA_OutputSimpleText(1,1,3,str);
	//type
	if(mid.type==0){
		PA_PlayPSG(9, 0, 0, 0, 0);  //
		return;
	}
	//keygvZ
	u8 note=imod(mid.key-36,12);
	s32 freq=freqs[note]*pow(2.0f,(mid.key-36)/12);
	u8 vol=64;
	PA_PlayPSG(9, 0, 0, 0, 0);  //
	PA_PlayPSG(9, vol, 50,freq,3);//炷
	return;
}

int main(){
	//
	PA_Init();
	PA_InitVBL();
	PA_InitText(1,1);
	//NX
	DetuneMIDILoader midi_sys;
	//Q[[v
	while(true){
		if(Pad.Newpress.X){//Jn
			midi_sys.SetDetuneMIDI(test,test_size,MidiCallBack);
			PA_VBLCounterStart(0);//0~15
		}
		PA_OutputText(1, 0, 2, "%d VBLs,%d seconds",PA_VBLCounter[0],PA_VBLCounter[0]/60);
		midi_sys.Update(PA_VBLCounter[0]);
	}
}


